package me.totalfreedom.totalfreedommod.api.event;

import me.totalfreedom.totalfreedommod.rank.Displayable;
import net.kyori.adventure.key.Key;
import net.kyori.adventure.text.Component;
import org.bukkit.event.Event;
import org.bukkit.event.HandlerList;
import org.jetbrains.annotations.NotNull;

public class AdminChatEvent extends Event
{
    private static HandlerList handlerList = new HandlerList();
    //--
    private Key identifier;
    private Component prefix = Component.empty();
    private Component name;
    private Displayable displayable;
    private Component message;

    public AdminChatEvent(Key identifier, Component prefix, Component name, Displayable rank, Component message, boolean async)
    {
        super(async);
        this.identifier = identifier;
        this.prefix = prefix;
        this.name = name;
        this.displayable = rank;
        this.message = message;
    }

    public AdminChatEvent(Component name, Displayable rank, Component message, boolean async)
    {
        super(async);
        this.identifier = Key.key("tfm", "default");
        this.name = name;
        this.displayable = rank;
        this.message = message;
    }

    public static HandlerList getHandlerList()
    {
        return handlerList;
    }

    @Override
    public @NotNull HandlerList getHandlers()
    {
        return handlerList;
    }

    public Key getIdentifier()
    {
        return identifier;
    }

    public Component getPrefix()
    {
        return prefix;
    }

    public Component getName()
    {
        return name;
    }

    public Displayable getDisplayable()
    {
        return displayable;
    }

    public Component getMessage()
    {
        return message;
    }
}
