package me.totalfreedom.totalfreedommod.command;

import me.totalfreedom.totalfreedommod.command.handling.*;
import me.totalfreedom.totalfreedommod.rank.Hierarchy;
import me.totalfreedom.totalfreedommod.util.FLog;
import me.totalfreedom.totalfreedommod.util.FUtil;
import net.kyori.adventure.text.minimessage.tag.resolver.Placeholder;
import org.bukkit.Bukkit;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

import java.util.concurrent.atomic.AtomicBoolean;

@Intercept("deop")
@CommandPermissions(permission = "deop", source = SourceType.BOTH)
@CommandParameters(description = "Deop a player", usage = "/<command> <partialname>")
public class Command_deop extends FreedomCommand
{
    @Override
    public boolean run(CommandSender sender, Player playerSender, Command cmd, String commandLabel, String[] args, boolean senderIsConsole)
    {
        if (args.length < 1)
        {
            return false;
        }

        boolean silent = false;
        if (args.length == 2)
        {
            silent = args[1].equalsIgnoreCase("-s");
        }

        Player player = Bukkit.getServer().getPlayer(args[0]);

        if (player == null || plugin.al.isVanished(player.getUniqueId()))
        {
            msg(sender, PLAYER_NOT_FOUND);
            return true;
        }

        AtomicBoolean atomicBoolean = new AtomicBoolean(silent);
        Hierarchy.getHierarchy().demoteUser(Hierarchy.getHierarchy().op(), player).whenComplete((result, throwable) ->
        {
            if (throwable != null)
            {
                msgNew("<red>Could not demote <player> to non-OP. Check the logs for more details.", player(player));
                FLog.severe("Error while demoting " + player.getName() + " to non-OP:");
                FLog.severe(throwable);
                return;
            }

            if (result == null || !result.wasSuccessful()) {
                msgNew("<red><player> is already non-op.", Placeholder.unparsed("player", player.getName()));
                return;
            }

            msg(player, YOU_ARE_NOT_OP);

            if (!atomicBoolean.get())
            {
                FUtil.adminAction(sender.getName(), "De-opping " + player.getName(), false);
            }
        });

        return true;
    }
}