package me.totalfreedom.totalfreedommod.command;

import me.totalfreedom.totalfreedommod.command.handling.CommandParameters;
import me.totalfreedom.totalfreedommod.command.handling.CommandPermissions;
import me.totalfreedom.totalfreedommod.command.handling.FreedomCommand;
import me.totalfreedom.totalfreedommod.command.handling.SourceType;
import me.totalfreedom.totalfreedommod.rank.Hierarchy;
import me.totalfreedom.totalfreedommod.util.FLog;
import me.totalfreedom.totalfreedommod.util.FUtil;
import net.kyori.adventure.text.minimessage.tag.resolver.Placeholder;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

@CommandPermissions(permission = "deop.all", source = SourceType.BOTH, blockHostConsole = true)
@CommandParameters(description = "Deop everyone on the server.", usage = "/<command>")
public class Command_deopall extends FreedomCommand
{

    @Override
    public boolean run(CommandSender sender, Player playerSender, Command cmd, String commandLabel, String[] args, boolean senderIsConsole)
    {
        FUtil.adminAction(sender.getName(), "De-opping all players on the server", true);

        server.getOnlinePlayers().forEach(player ->
                Hierarchy.getHierarchy().demoteUser(Hierarchy.getHierarchy().op(), player).whenComplete((result, ex) ->
                {
                    if (ex != null)
                    {
                        msgNew("<red>Could not demote <player> to non-OP. Check the logs for more details.", player(player));
                        FLog.severe("Failed to demote " + player.getName() + " to non-OP:");
                        FLog.severe(ex);
                        return;
                    }

                    if (result == null || !result.wasSuccessful()) {
                        msgNew("<red><player> is already non-OP.", Placeholder.unparsed("player", player.getName()));
                        return;
                    }

                    msg(player, YOU_ARE_NOT_OP);
                }));

        return true;
    }
}
