package me.totalfreedom.totalfreedommod.command;

import me.totalfreedom.totalfreedommod.command.handling.*;
import me.totalfreedom.totalfreedommod.rank.Hierarchy;
import me.totalfreedom.totalfreedommod.util.FLog;
import me.totalfreedom.totalfreedommod.util.FUtil;
import org.bukkit.Bukkit;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

import java.util.concurrent.atomic.AtomicBoolean;

@Intercept("op")
@CommandPermissions(permission = "op", source = SourceType.BOTH, cooldown = 5)
@CommandParameters(description = "OP a player", usage = "/<command> <partialname>")
public class Command_op extends FreedomCommand
{

    @Override
    public boolean run(CommandSender sender, Player playerSender, Command cmd, String commandLabel, String[] args, boolean senderIsConsole)
    {
        if (args.length < 1)
        {
            return false;
        }

        boolean silent = false;
        if (args.length == 2)
        {
            silent = args[1].equalsIgnoreCase("-s");
        }

        Player player = Bukkit.getServer().getPlayer(args[0]);

        if (player == null || plugin.al.isVanished(player.getUniqueId()))
        {
            msg(sender, PLAYER_NOT_FOUND);
            return true;
        }

        AtomicBoolean atomicBoolean = new AtomicBoolean(silent);
        Hierarchy.getHierarchy().promoteUser(Hierarchy.getHierarchy().op(), player).whenComplete((result, throwable) ->
        {
            if (throwable != null)
            {
                msgNew("<red>Failed to promote <player> to OP. Check logs for more details.", player(player));
                FLog.severe("Failed to promote " + player.getName() + " to OP:");
                FLog.severe(throwable);
                return;
            }

            if (result == null) {
                msgNew("<red><player> was not on the track! Added.", player(player));
            }
            else if (!result.wasSuccessful())
            {
                msgNew("<red><player> is already OP!", player(player));
                return;
            }

            msg(player, YOU_ARE_OP);

            if (!atomicBoolean.get())
            {
                FUtil.adminAction(sender.getName(), "Opping " + player.getName(), false);
            }
        });


        return true;
    }
}