package me.totalfreedom.totalfreedommod.command;

import me.totalfreedom.totalfreedommod.command.handling.CommandParameters;
import me.totalfreedom.totalfreedommod.command.handling.CommandPermissions;
import me.totalfreedom.totalfreedommod.command.handling.FreedomCommand;
import me.totalfreedom.totalfreedommod.command.handling.SourceType;
import me.totalfreedom.totalfreedommod.rank.Hierarchy;
import me.totalfreedom.totalfreedommod.util.FLog;
import me.totalfreedom.totalfreedommod.util.FUtil;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

@CommandPermissions(permission = "op.all", source = SourceType.BOTH, cooldown = 30)
@CommandParameters(description = "OP everyone on the server.", usage = "/<command>")
public class Command_opall extends FreedomCommand
{
    @Override
    public boolean run(CommandSender sender, Player playerSender, Command cmd, String commandLabel, String[] args, boolean senderIsConsole)
    {
        FUtil.adminAction(sender.getName(), "Opping all players on the server", true);

        server.getOnlinePlayers().forEach(player ->
                Hierarchy.getHierarchy().promoteUser(Hierarchy.getHierarchy().op(), player).whenComplete((result, throwable) ->
                {
                    if (throwable != null)
                    {
                        msgNew("<red>Failed to promote <player> to OP. Check the logs for more details.", player(player));
                        FLog.severe("Failed to promote " + player.getName());
                        FLog.severe(throwable);
                        return;
                    }

                    if (result == null) {
                        msgNew("<red><player> was not present on the track! Added.", player(player));
                    } else if (!result.wasSuccessful()) {
                        msgNew("<red>Player is already OP!", player(player));
                        return;
                    }

                    msg(player, YOU_ARE_OP);
                }));

        return true;
    }
}