package me.totalfreedom.totalfreedommod.command.handling;

import me.totalfreedom.totalfreedommod.TotalFreedomMod;
import me.totalfreedom.totalfreedommod.util.FLog;
import org.bukkit.Bukkit;
import org.bukkit.command.Command;
import org.bukkit.command.PluginIdentifiableCommand;

import java.util.HashMap;
import java.util.Map;

public class Interceptor
{
    private final TotalFreedomMod plugin;
    private final Map<String, Command> overrides = new HashMap<>();

    public Interceptor(TotalFreedomMod plugin)
    {
        this.plugin = plugin;
    }

    public void intercept(String command)
    {
        getPluginCommands().entrySet()
                .stream()
                .filter(entry -> !((PluginIdentifiableCommand) entry.getValue()) // Check that it isn't a tfm command
                        .getPlugin()
                        .getName()
                        .equalsIgnoreCase(plugin.getName()))
                .filter(entry -> entry.getValue() // Check that the command is the one we want to intercept
                        .getName()
                        .equalsIgnoreCase(command))
                .forEach(entry -> overrides.put(entry.getKey(), entry.getValue())); // Intercept.

        getFallbackCommands().entrySet()
                .stream()
                .filter(entry -> entry.getValue() // Check that the command is the one we want to intercept
                        .getName()
                        .equalsIgnoreCase(command))
                .forEach(entry -> overrides.put(entry.getKey(), entry.getValue())); // Intercept.
    }

    public void setOverrides()
    {
        overrides.forEach((key, value) ->
        {
            Bukkit.getCommandMap().getKnownCommands().remove(key, value);
            FLog.info("Overriding command: " + key);
        });
    }

    private Map<String, Command> getFallbackCommands() {
        final Map<String, Command> fallbackCommands = new HashMap<>();
        for (final Map.Entry<String, Command> entry : Bukkit.getCommandMap().getKnownCommands().entrySet()) {
            if (!(entry.getValue() instanceof PluginIdentifiableCommand)) {
                fallbackCommands.put(entry.getKey(), entry.getValue());
            }
        }
        return fallbackCommands;
    }

    private Map<String, Command> getPluginCommands()
    {
        final Map<String, Command> pluginCommands = new HashMap<>();
        for (final Map.Entry<String, Command> entry : Bukkit.getCommandMap().getKnownCommands().entrySet())
        {
            if (entry.getValue() instanceof PluginIdentifiableCommand)
            {
                pluginCommands.put(entry.getKey(), entry.getValue());
            }
        }
        return pluginCommands;
    }
}
