package me.totalfreedom.totalfreedommod.perms;

import net.luckperms.api.model.group.Group;
import net.luckperms.api.model.group.GroupManager;

import java.util.concurrent.CompletableFuture;

public class GroupWrapper
{
    private final GroupManager manager;

    public GroupWrapper(GroupManager manager)
    {
        this.manager = manager;
    }

    public CompletableFuture<Group> getGroup(String name)
    {
        if (!manager.isLoaded(name) || !manager.getLoadedGroups().contains(manager.getGroup(name)))
        {
            return manager.createAndLoadGroup(name);
        }

        return CompletableFuture.supplyAsync(() -> manager.getGroup(name));
    }

    public void saveGroup(String name)
    {
        getGroup(name).thenAccept(manager::saveGroup);
    }
}
