package me.totalfreedom.totalfreedommod.perms;

import net.luckperms.api.track.Track;
import net.luckperms.api.track.TrackManager;

import java.util.HashSet;
import java.util.Set;
import java.util.concurrent.CompletableFuture;

public class TrackWrapper
{
    private final TrackManager manager;
    private final Set<Track> trackSet;

    public TrackWrapper(TrackManager manager)
    {
        this.manager = manager;
        this.trackSet = new HashSet<>();
        trackSet.addAll(manager.getLoadedTracks());
    }

    public CompletableFuture<Track> getTrack(String name)
    {
        if (!manager.isLoaded(name) || !trackSet.contains(manager.getTrack(name)))
        {
            return manager.createAndLoadTrack(name).thenApplyAsync(a -> {
                trackSet.add(a);
                return a;
            });
        }

        return CompletableFuture.supplyAsync(() -> manager.getTrack(name));
    }

    public void saveTrack(String name)
    {
        getTrack(name).thenAccept(manager::saveTrack);
    }
}
